/*̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief FAT޽
 *
 * ̧قFAT޽pͯނłB
 *
 * \author	Atmel Corporation	: http://www.atmel.com \n
 *			xFAQ			: http://support.atmel.no/
 *
 *****************************************************************************/

/* 쌠 (c) 2006-2008, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

#ifndef _FAT_H_
#define _FAT_H_

#include "fs_com.h"

//! @verbatim
//! - ̧ їp:
//! MBR : ް ں(4PE܂)
//! PE  : ߰èݓ(PBRɂĂ̈ʒu܂)
//! PBR : ߰è ް ں
//! BPB : BIOSҰ(ʰ޳FATB)
//! PBR = BPB
//! FAT : ̧ي蓖ĕ\
//! @endverbatim

#undef _GLOBEXT_
#if (defined _fat_c_)
  #define _GLOBEXT_
#else
  #define _GLOBEXT_ extern
#endif

//_____ ݸٰ ____________________________________________________________

//_____ ϸ ________________________________________________________________

// ނ̍œK̂
#if (FS_FAT_12 == ENABLED)
  #define Is_fat12		(FS_TYPE_FAT_12 == fs_g_nav_fast.u8_type_fat)
#else
  #define Is_fat12		(0)
#endif
#if (FS_FAT_16 == ENABLED)
  #define Is_fat16		(FS_TYPE_FAT_16 == fs_g_nav_fast.u8_type_fat)
#else
  #define Is_fat16		(0)
#endif
#if (FS_FAT_32 == ENABLED)
  #define Is_fat32		(FS_TYPE_FAT_32 == fs_g_nav_fast.u8_type_fat)
#else
  #define Is_fat32		(0)
#endif

// ނ̍œK̂
#if ( (FS_ASCII   == ENABLED) && (FS_UNICODE == ENABLED))
  #define Is_unicode	(g_b_unicode)
#elif (FS_ASCII   == ENABLED)
  #define Is_unicode	(0)
#elif (FS_UNICODE == ENABLED)
  #define Is_unicode	(1)
#else
  #error You must define FS_ASCII or/and FS_UNICODE enable in conf_explorer.h
#endif

//_____ ` _______________________________________________________________

//**** WFATɑΉ` ****

//! ߰èݓMBR(޲ĒPʂ)ʒu
#define FS_MBR_OFFSET_PART_ENTRY( num )	((U16)((U16)(0x1BE)+(0x10 * num)))	// ߰èݓԍ(0`3)

//! \name BPB̗̈𱸾邽߂ϸ(fat_mount()֐ł̂ݎgp)
//! "BPB_"ɂĐړ閼O"ʰ޳FAT"Œ`܂B
//! @{
#define LOW_16_BPB_BytsPerSec	fs_g_sector[11]
#define HIGH_16_BPB_BytsPerSec	fs_g_sector[12]
#define U8_BPB_SecPerClus		fs_g_sector[13]
#define LOW_16_BPB_RootEntCnt	fs_g_sector[17]
#define HIGH_16_BPB_RootEntCnt	fs_g_sector[18]
#define LOW_16_BPB_FATSz16		fs_g_sector[22]
#define HIGH_16_BPB_FATSz16		fs_g_sector[23]
#define LOW0_32_BPB_FATSz32		fs_g_sector[36]
#define LOW1_32_BPB_FATSz32		fs_g_sector[37]
#define LOW2_32_BPB_FATSz32		fs_g_sector[38]
#define LOW3_32_BPB_FATSz32		fs_g_sector[39]
#define LOW_16_BPB_TotSec16		fs_g_sector[19]
#define HIGH_16_BPB_TotSec16	fs_g_sector[20]
#define LOW0_32_BPB_TotSec32	fs_g_sector[32]
#define LOW1_32_BPB_TotSec32	fs_g_sector[33]
#define LOW2_32_BPB_TotSec32	fs_g_sector[34]
#define LOW3_32_BPB_TotSec32	fs_g_sector[35]
#define LOW_16_BPB_ResvSecCnt	fs_g_sector[14]
#define HIGH_16_BPB_ResvSecCnt	fs_g_sector[15]
#define U8_BPB_NumFATs			fs_g_sector[16]
#define LOW0_32_BPB_RootClus	fs_g_sector[44]
#define LOW1_32_BPB_RootClus	fs_g_sector[45]
#define LOW2_32_BPB_RootClus	fs_g_sector[46]
#define LOW3_32_BPB_RootClus	fs_g_sector[47]
#define LOW_16_BPB_FSInfo		fs_g_sector[48]
#define HIGH_16_BPB_FSInfo		fs_g_sector[49]
//! @}

//! \name MBR܂PBR̾̂Ɏgp萔
//! @{
#define FS_BR_SIGNATURE_LOW		0x55
#define FS_BR_SIGNATURE_HIGH	0xAA
//! @}

//! \name MBRŎgp萔
//! @{
#define FS_PART_BOOTABLE		0x80
#define FS_PART_NO_BOOTABLE		0x00
/*
   ߰è Fdisk
   `          e               FAT`  OS
   -----------------------------------------------------------------------------
   01       PRI DOS  0`15Mo            12ޯ   MS-DOS 2.0
   04       PRI DOS  16`32Mo           16ޯ   MS-DOS 3.0
   05       EXT DOS  0`2Go             N/A      MS-DOS 3.3
   06       PRI DOS  32Mo`2Go          16ޯ   MS-DOS 4.0
   0E       PRI DOS  32Mo`2Go          16ޯ   Windows 95
   0F       EXT DOS  0`2Go             N/A      Windows 95
   0B       PRI DOS  512Mo`2To(ï)  32ޯ   OSR2
   0C       EXT DOS  512Mo`2To(ï)  32ޯ   OSR2
*/
#define FS_PART_TYPE_FAT12				0x01
#define FS_PART_TYPE_FAT16_INF32M		0x04
#define FS_PART_TYPE_FAT16_SUP32M		0x06
#define FS_PART_TYPE_FAT16_SUP32M_BIS	0x0E
#define FS_PART_TYPE_FAT32				0x0B
#define FS_PART_TYPE_FAT32_BIS			0x0C
#define FS_PART_REMOVE_MEDIA			0xF0	// O}
#define FS_PART_NO_REMOVE_MEDIA			0xF8	// Os}
#define FS_PART_HARD_DISK				0x81	// ʰި
#define FS_BOOT_SIGN					0x29	// ްĎ[
//! @}

//! \name őFAT׽
//! @{
#define FS_FAT12_MAX_CLUSTERS		4085	// FAT12pő׽
#define FS_FAT16_MAX_CLUSTERS		65525	// FAT16pő׽
//! @}

//! \name ̧ٓ̐擪޲ĂŎgp萔
//! @{
#define FS_ENTRY_END				0x00	// ިڸ؂̍Ō
#define FS_ENTRY_DEL				0xE5	// 폜ꂽ
#define FS_ENTRY_LFN_LAST			0x40	// Ō̒O̓o邽߂̎Օ
//! @}

//! \name ̧ٓǗ̂Ɏgp萔
//! @{
#define FS_SIZE_FILE_ENTRY			32		// ̧ٓ̑傫
#define FS_SHIFT_B_TO_FILE_ENTRY	 5		// ޲ĒPʂ̧ٓPʂւ̈ړ(32,<<5)A512޲ Pʂւ(512,>>9)
#define FS_SIZE_LFN_ENTRY			13		// "̧ٖ"̧ٓŊi[閼Ȏ傫(UNICODE2޲ĒP)
#define FS_SIZE_SFNAME				11		// "Z̧ٖ"̧ٓŊi[閼Ȏ傫(޲ĒP)
#define FS_SIZE_SFNAME_WITHOUT_EXT	 8		// "Z̧ٖ"̧ٓŊi[(gq)Ȏ傫(޲ĒP)
#define FS_SIZE_SFNAME_EXT_ONLY		 3		// "Z̧ٖ"̧ٓŊi[gq̑傫(޲ĒP)
//! @}

//! \name ̧ т̐
//! @{
#define FS_NB_FAT					2		// ̧ т2FATǗ܂B
//! @}

//**** ֐`Ԑݒ̒`

//! \name 512޲ĒPʂ̧̾ ъKwőgp܂B
//! @{
#define FS_512B						512
#define FS_512B_MASK				(512-1)
#define FS_512B_SHIFT_BIT			9					// ޲ĒPʂPʂւ̈ړ(512,>>9)
#define FS_SIZE_OF_SECTOR			FS_512B				// ̧ ѕƂ̓Kp
#define FS_MASK_SIZE_OF_SECTOR		FS_512B_MASK		// ̧ ѕƂ̓Kp
#define FS_SHIFT_B_TO_SECTOR		FS_512B_SHIFT_BIT	// ̧ ѕƂ̓Kp
#define FS_CACHE_SIZE				512					// ɂĎgp鷬e(512޲ĒP)
//! @}

//!  LłȂƂ}
#define FS_BUF_SECTOR_EMPTY			0xFF

//! \name fat_checkcluster()֐̏
//! @{
#define FS_CLUS_OK					0		// l
#define FS_CLUS_BAD					1		// l
#define FS_CLUS_END					2		// ׽ꗗ̍Ō
//! @}

//! \name fat_cluster_list()֐̔CӑI
//! @{
#define FS_CLUST_ACT_SEG			0x01	// ׽ ڽƸꗗ̑傫𓾂
#define FS_CLUST_ACT_ONE			0x02	// ׽ꗗ̾ ڽ𓾂
#define FS_CLUST_ACT_CLR			0x03	// ׽ꗗ
//! @}

//! \name fat_cluster_val()֐̔CӑI
//! @{
#define FS_CLUST_VAL_READ			FALSE		// ǂݍݓ
#define FS_CLUST_VAL_WRITE			TRUE		// ݓ
#define FS_CLUST_VAL_EOL			0x0FFFFFFF	// ׽ꗗ̍Ō}邽߂̒l
//! @}

//! \name ̧ ѐtɂĂ̏i[̂Ɏgp\
//! @{

//! ٰ ިڸ؂`鋤p
typedef union
{
	U32  u32_cluster;						//!< FAT32pAٰ ިڸ؂͸׽ꗗ
	struct
	{
		U16 u16_pos;						//!< FAT̎n߂ٰ ިڸ؂̎nߊԂ̕ψ(512޲ĒP)
		U16 u16_size;						//!< ٰĂ̑傫(512޲ĒP)
	} seg;									//!< FAT12/16pA;(׽ꗗł͂܂B)
} Fs_rootdir;

//! tꂽ̧ тɂĕpɂɎgpϐۑ\
typedef struct
{
	U8			u8_lun;						//!< _ײސ
#if (FS_MULTI_PARTITION == ENABLED)
	U8			u8_partition;				//!< ߰èݐ-1(0܂1)
#endif
	U8			u8_BPB_SecPerClus;			//!< ׽̑傫(512޲ĒP)
	// ߲؂̐擪Ŏn܂A512޲ĒPʂłB
	U16			u16_fat_size;				//!< 1FAT̑傫(512޲ĒP)
	U16			u16_offset_FSInfo;			//!< FAT̎n߂FSԂ̕ψ(FAT32ɂĎgp邾)(512޲ĒP)
	U32			u32_CountofCluster;			//!< (2̗\׽܂)׽
	U32			u32_ptr_fat;				//!< FATڽ(512޲ĒP)
	U32			u32_offset_data;			//!< FAT̎n߂ƍŏ׽Ԃ̕ψ(512޲ĒP)
	Fs_rootdir	rootdir;					//!< ٰ ިڸ؏
	U16			u16_entry_pos_sel_dir;		//!< eިڸؓőIިڸ؂̈ʒu(ިڸؖ𓾂ٰ݂̍̂߂Ɏgp)
	U32			u32_cluster_sel_dir;		//!< Iިڸ؂̍ŏ̸׽ԍ(ٰ ިڸ؂ɑ΂0)
	U16			u16_pos_sel_file;			//!< ̧وꗗ̧وʒu(U֐ɂĂ̂ݎgp)
	U16			u16_pos_filterlist;			//!< h߂ꂽ̧وꗗ̧وʒu(nav_filterlist֐ɑ΂Ă̂)
	FS_STRING	sz_filterext;				//!< nav_filterlist֐Ŏgp邽߂̊gqh߂ł߲
	U8			b_mode_nav;					//!< UiK(FS_FILE܂FS_DIR)
	U8			b_mode_nav_single;			//!< U̧وꗗ̧ق܂ިڸ؂񋟂܂B
	U8			u8_flat_dir_level;			//!< Rꗗł݂̌ިڸ؂ިڸ 
	U16			u16_flat_pos_offset;		//!< ިڸ؂̕Rꗗ̕ψ
} Fs_management;

//! tꂽ̧ тɂĔȕpxŎgpϐۑ\
typedef struct
{
	U8		u8_type_fat;					//!< FAT`(=tȂ=FS_TYPE_FAT_UNM)
	U16		u16_entry_pos_sel_file;			//!< ިڸ̧ؓٓʒu(P=FS_SIZE_FILE_ENTRY) (FS_NO_SELFS_END_FINDlB)
} Fs_management_fast;

//! tꂽ̧ т̕ϐxXۑ\
typedef struct
{
	U8		u8_open_mode;					//!< I̧ق̊J
	U8		u8_txt_format;					//!< I̧قŎgp镶͌`(reader_txtp̂)
	U8		u8_attr;						//!< I̧ق̑
	U32		u32_cluster;					//!< I̧ق̐擪׽
	U32		u32_size;						//!< I̧ٗe(޲ĒP)
	U32		u32_pos_in_file;				//!< ̧݈ٓ̌ʒu(޲ĒP)
} Fs_management_entry;
//! @}

//! \name \
//! @{

//! Ē`̍\
typedef struct
{
	U32		u32_addr;						//!<  ڽ(512޲ĒP)A܂͸׽ԍ
	U32		u32_size_or_pos;				//!< ėe(512޲ĒP)A܂͸׽ꗗ̈ʒu(512޲ĒP)
} Fs_segment;

//! ׽i[\
typedef struct st_fs_cluster
{
	U32		u32_pos;						//!< ׽ʒu
	U32		u32_val;						//!< ׽l
} Fs_cluster;

//! @}

//! ׽ꗗi[\
typedef struct {
	Bool	b_cache_file;					//!< ̧ ׽ꗗ܂ިڸ ׽ꗗ̸׽ }
	U8		u8_level_use;					//!<  فAŌ̎gpɑ΂0Aɑ΂čőFS_NB_CACHE_CLUSLIST-1(FS_NB_CACHE_CLUSLIST=1ȂΖ)
	U8		u8_lun;							//!< ׽ꗗLUN
	U32		u32_cluster;					//!< ׽ꗗ̐擪׽
	U32		u32_start;						//!< ׽ꗗ̊Jnʒu(512޲ĒP)
	U32		u32_addr;						//!< ׽ꗗ"Jn"ʒuɑΉڽ
	U32		u32_size;						//!< ׽ꗗe
} Fs_clusterlist_cache;

//!  (=ިœǂ/Ō̾ɂĂ̏i[\
typedef struct
{
	U8		u8_lun;							//!< LUN
	U32		u32_addr;						//!<  ڽ(512޲ĒP)
	U8		u8_dirty;						//!<  ڽ(512޲ĒP)
											//!< ׽ꗗ̾ȂA׽ꗗ̐擪׽
	U32		u32_clusterlist_start;			//!< ׽ꗗ̐擪׽
	U32		u32_clusterlist_pos;			//!< ׽ꗗ̈ʒu(512޲ĒP)
} Fs_sector_cache;

//**** ʐM̍\̂ɂĎgpl̒`

//! \name "Fs_management_fast.u8_type_fat"ŎgpFAT`ID
//! @{
#define FS_TYPE_FAT_UNM			0			//!< ߰èݐtȂ
#define FS_TYPE_FAT_12			1
#define FS_TYPE_FAT_16			2
#define FS_TYPE_FAT_32			3
//! @}

//! \name "Fs_management_fast.u16_entry_pos_sel_file"Ŏgpl
//! @{
#define FS_NO_SEL				0xFFFF		//!< ̧ٓIĂȂƂ}
#define FS_END_FIND				0xFFFE		//!< ̧ٓтɂı\ȍŌ̧ٓł邱Ƃ}
//! @}

//! \name ̧قJ`Ԃ𒲂ׂϸ
//! @{
#define Fat_file_is_open()		(fs_g_nav_entry.u8_open_mode !=0 )
#define Fat_file_isnot_open()	(fs_g_nav_entry.u8_open_mode ==0 )
#define Fat_file_close()		(fs_g_nav_entry.u8_open_mode  =0 )
//! @}

//_____ 錾 _______________________________________________________________

//**** ̧ ёSϐ

//! (nav_reset()ŏꂽ)`Iϐ
_GLOBEXT_						Bool					g_b_unicode;
//! (nav_reset()ŏꂽ)LENGTHʂIϐ
_GLOBEXT_						Bool					g_b_string_length;

//! ިł̊eOި/֎~ϐ
_GLOBEXT_						Bool					g_b_no_check_disk;

//! \name drive_mount()ŏϐ
//! @{
_GLOBEXT_	_MEM_TYPE_SLOW_		Fs_management			fs_g_nav;
_GLOBEXT_	_MEM_TYPE_FAST_		Fs_management_fast		fs_g_nav_fast;
_GLOBEXT_	_MEM_TYPE_SLOW_		Fs_management_entry		fs_g_nav_entry;
//! @}

//! ̊֐ɂēxXgpϐ(œKA֐ҰȂ)
_GLOBEXT_	_MEM_TYPE_FAST_		Fs_segment				fs_g_seg;

//! fat_getfreespace, fat_cluster_list, fat_cluster_val, fat_checkcluster̊֐ŎԂ邽
_GLOBEXT_	_MEM_TYPE_FAST_		Fs_cluster				fs_g_cluster;

#if (FS_LEVEL_FEATURES > FSFEATURE_READ)
//! \name 2FATXV̂Ɏgpϐ
//! @{
_GLOBEXT_	_MEM_TYPE_SLOW_		U16						fs_g_u16_first_mod_fat;	//!< ŏ̾(512޲ĒP)FATł̕ψ(512޲ĒP)
_GLOBEXT_	_MEM_TYPE_SLOW_		U16						fs_g_u16_last_mod_fat;	//!< Ō̾(512޲ĒP)FATł̕ψ(512޲ĒP)
//! @}
#endif // FS_LEVEL_FEATURES

//! \name  Ǘ̂Ɏgpϐ
//! @{
_GLOBEXT_	_MEM_TYPE_SLOW_		U8						fs_g_sector[ FS_CACHE_SIZE ];
_GLOBEXT_	_MEM_TYPE_SLOW_		Fs_sector_cache			fs_g_sectorcache;
_GLOBEXT_	_MEM_TYPE_SLOW_		U32						fs_gu32_addrsector;		//!< ̷̱ڽi[(512޲ĒP)
typedef U8	_MEM_TYPE_SLOW_		* PTR_CACHE;
//!}@

//! \name ȔԂmF֐
//! @{
Bool fat_check_device				(void);
Bool fat_check_mount				(void);
Bool fat_check_noopen				(void);
Bool fat_check_open					(void);
Bool fat_check_select				(void);
Bool fat_check_mount_noopen			(void);
Bool fat_check_mount_select_noopen	(void);
Bool fat_check_mount_select_open	(void);
Bool fat_check_mount_select			(void);
Bool fat_check_is_file				(void);
//! @}

//! ̊֐͑Iײޏɑ݂߰èݐԂ܂B
U8		fat_get_nbpartition			( void );

//! ̊֐߰è݂𐘕t܂B
Bool	fat_mount					( void );

//! ̊֐ײނ̫ϯĂ܂B
Bool	fat_format					( U8 u8_fat_type );

//! ̊֐͒ʔԂǂ݂܂͏܂B
Bool	fat_serialnumber			( Bool b_action , U8 _MEM_TYPE_SLOW_ *a_u8_sn );

//! \name ߰èݏ̋󂫋ԂvZ֐
//! @{
U32		fat_getfreespace			(void);
U8		fat_getfreespace_percent	(void);
Bool	fat_write_fat32_FSInfo		(U32 u32_nb_free_cluster);
U32		fat_read_fat32_FSInfo		(void);
//! @}

//! \name ꗗǗ֐
//! @{
Bool	fat_cluster_list			(U8 opt_action, Bool b_for_file);
void	fat_cache_clusterlist_reset	(void);
Bool	fat_cluster_val				(Bool b_mode);
Bool	fat_cluster_readnext		(void);
U8		fat_checkcluster			(void);
Bool	fat_allocfreespace			(void);
void	fat_clear_info_fat_mod		(void);
Bool	fat_clear_cluster			(void);
Bool	fat_update_fat2				(void);
//! @}

//! \name ̧ق܂ިڸ؂ǂ݂܂͏֐
//! @{
Bool	fat_read_file				(U8 mode);
Bool	fat_write_file				(U8 mode, U32 u32_nb_sector_write);
Bool	fat_read_dir				(void);
Bool	fat_initialize_dir			(void);
//! @}

//! \name ̈(fat.c)Ǘ֐
//! @{
Bool	fat_entry_check					(Bool b_type);
Bool	fat_entry_checkext				(FS_STRING sz_filter);
void	fat_get_entry_info				(void);
Bool	fat_entry_is_dir				(void);
void	fat_clear_entry_info_and_ptr	(void);
void	fat_write_entry_file			(void);
Bool	fat_entry_shortname				(FS_STRING sz_name, U8 u8_size_max, Bool b_mode);
Bool	fat_entry_longname				(FS_STRING sz_name, U8 u8_size_max, Bool b_mode, Bool b_match_case);
Bool	fat_check_eof_name				(U16 character);
PTR_CACHE	fat_get_ptr_entry			(void);
//! @}

//! \name ̈(fat_unusual.c)Ǘ֐
//! @{
Bool	fat_create_entry_file_name	(FS_STRING sz_name);
void	fat_get_date				(FS_STRING sz_date, Bool type_date);
void	fat_set_date				(const FS_STRING sz_date, Bool type_date);
Bool	fat_delete_file				(Bool b_cluster_list);
Bool	fat_entry_label				(Bool b_action, FS_STRING sz_label);
//! @}

//! \name Ǘ֐
//! @{
Bool	fat_cache_read_sector			(Bool b_load);
void	fat_cache_reset					(void);
void	fat_cache_clear					(void);
void	fat_cache_mark_sector_as_dirty	(void);
Bool	fat_cache_flush					(void);
//! @}

//! \name ި 𐧌䂷֐
//! @{
#if (FS_NB_NAVIGATOR > 1)
	Bool	fat_check_nav_access_disk	(void);
	Bool	fat_check_nav_access_file	(Bool mode);
#else
  #define fat_check_nav_access_disk(b)	(TRUE)		//! 1̗ȔꍇA֐͎gp܂B
  #define fat_check_nav_access_file(b)	(TRUE)		//! 1̗ȔꍇA֐͎gp܂B
#endif
//! @}

//! \name U؂ւǗ֐
//! @{
#if (FS_NB_NAVIGATOR > 1)
	void	fat_invert_nav				(U8 u8_idnav);
	void	fat_copy_nav				(U8 u8_idnav);
#else
  #define fat_invert_nav				(arg)  (arg++)	//! 1̗ȔꍇA֐͎gp܂B
  #define fat_copy_nav					(arg)  (arg++)	//! 1̗ȔꍇA֐͎gp܂B
#endif
//! @}

#endif // _FAT_H_
