/*/*̧قDoxygenpɏĂ܂B*/
//! \file *********************************************************************
//! SPIײޓo
//! \brief
//!
//! - ߲		: AVRpIAR EWAVRGNU GCC
//! - x޲	: AT90USB1287, AT90USB1286, AT90USB647, AT90USB646
//!
//! \author	Atmel Corporation	: http://www.atmel.com \n
//!			xFAQ			: http://support.atmel.no/
//!
//! ***************************************************************************

/* 쌠 (c) 2009, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

#ifndef _SPI_DRV_H_
#define _SPI_DRV_H_

//_____ ݸٰ _______________________________________________________________

#include "config.h"

//_____ ϸ ___________________________________________________________________

//----- ` -----
#define MSK_SPI_MODE			((1<<CPOL)|(1<<CPHA))
#define MSK_SPI_CPHA_LEADING	(0<<CPHA)
#define MSK_SPI_CPHA_TRAILING	(1<<CPHA)
#define MSK_SPI_CPOL_LOW		(0<<CPOL)
#define MSK_SPI_CPOL_HIGH		(1<<CPOL)
#define SPI_MODE_0				(MSK_SPI_CPOL_LOW|MSK_SPI_CPHA_LEADING)
#define SPI_MODE_1				(MSK_SPI_CPOL_LOW|MSK_SPI_CPHA_TRAILING)
#define SPI_MODE_2				(MSK_SPI_CPOL_HIGH|MSK_SPI_CPHA_LEADING)
#define SPI_MODE_3				(MSK_SPI_CPOL_HIGH|MSK_SPI_CPHA_TRAILING)

//----- ޯđx -----
#define MSK_SPI_MULT2			0x80
#define MSK_SPR					((1<<SPR1)|(1<<SPR0))
#define MSK_SPI_DIV4			((0<<SPR1)|(0<<SPR0))
#define MSK_SPI_DIV16			((0<<SPR1)|(1<<SPR0))
#define MSK_SPI_DIV64			((1<<SPR1)|(0<<SPR0))
#define MSK_SPI_DIV128			((1<<SPR1)|(1<<SPR0))
#define SPI_RATE_0				(MSK_SPI_MULT2|MSK_SPI_DIV4)	// 2
#define SPI_RATE_1				(MSK_SPI_DIV4)					// 4
#define SPI_RATE_2				(MSK_SPI_MULT2|MSK_SPI_DIV16)	// 8
#define SPI_RATE_3				(MSK_SPI_DIV16)					// 16
#define SPI_RATE_4				(MSK_SPI_MULT2|MSK_SPI_DIV64)	// 32
#define SPI_RATE_5				(MSK_SPI_DIV64)					// 64
#define SPI_RATE_6				(MSK_SPI_DIV128)				// 128

//_____ ` __________________________________________________________________

// Sʋ
#define Spi_enable()			(SPCR |=  (1<<SPE))
#define Spi_disable()			(SPCR &= ~(1<<SPE))

// 荞݌`Ԑݒ
#define Spi_enable_it()			(SPCR |=  (1<<SPIE))
#define Spi_disable_it()		(SPCR &= ~(1<<SPIE))

// SPI`Ԑݒ:]/呕u,`(ۯʑ,ۯɐ),ް,x
#define Spi_select_slave()		(SPCR &= ~(1<<MSTR))
#define Spi_select_master()		(SPCR |=  (1<<MSTR))
#define Spi_set_lsbfirst()		(SPCR |=  (1<<DORD))
#define Spi_set_msbfirst()		(SPCR &= ~(1<<DORD))
#define Spi_set_mode(mode)		{SPCR &= ~MSK_SPI_MODE; SPCR |= mode;}
#define Spi_set_rate(rate)		{SPCR &= ~MSK_SPR; SPCR |= rate&MSK_SPR; (rate & MSK_SPI_MULT2)?  Spi_set_doublespeed() : Spi_clear_doublespeed();}
#define Spi_set_doublespeed()	(SPSR |=  (1<<SPI2X))
#define Spi_clear_doublespeed()	(SPSR &= ~(1<<SPI2X))
#define Spi_init_bus()			((DDRB |= (1<<DDB2)|(1<<DDB1)))
#define Spi_disable_ss()
#define Spi_enble_ss()

// SPI
#define Spi_wait_spif()			while ((SPSR & (1<<SPIF)) == 0)		// ǂꂩSPI_RATE_xp
#define Spi_wait_eor()			while ((SPSR & (1<<SPIF)) == 0)		// MI҂
#define Spi_wait_eot()			while ((SPSR & (1<<SPIF)) == 0)		// MI҂
#define Spi_eor()				((SPSR & (1<<SPIF)) == (1<<SPIF))	// MI
#define Spi_eot()				((SPSR & (1<<SPIF)) == (1<<SPIF))	// MI
#define Spi_is_colision()		(SPSR&(1<<WCOL))
#define Spi_get_byte()			(SPDR)
#define Spi_tx_ready()			(SPSR & (1<<SPIF))
#define Spi_rx_ready()			Spi_tx_ready()
#define Spi_ack_read()			(SPSR)
#define Spi_ack_write()			(SPDR)
#define Spi_ack_cmd()			(SPSR)

// SPI]
#define Spi_read_data()			(SPDR)
#define Spi_write_data(byte)	{(SPDR=byte);Spi_wait_spif();}

#endif // _SPI_DRV_H_ 
